//===========================================================================
// package
//===========================================================================
package jp.gr.java_conf.bugslife.action;

//===========================================================================
// import
//===========================================================================
import java.io.IOException;
import java.util.Locale;
import javax.servlet.*;
import javax.servlet.http.*;
import org.apache.commons.logging.*;
import org.apache.struts.action.*;
import org.apache.struts.util.*;
import org.apache.commons.beanutils.*;

import java.util.*;

import jp.gr.java_conf.bugslife.selections.*;
import jp.gr.java_conf.bugslife.user.*;
import jp.gr.java_conf.bugslife.bug.*;
import jp.gr.java_conf.bugslife.db.*;
import jp.gr.java_conf.bugslife.form.*;
import jp.gr.java_conf.bugslife.system.*;
import jp.gr.java_conf.bugslife.util.Converter;
import jp.gr.java_conf.bugslife.util.Assert;
import jp.gr.java_conf.bugslife.util.Varidater;
/**
 *<PRE>
 * 
 * BugDetail2Actionクラス
 *
 *</PRE>
 * @version	0.0
 * @author	鰐川 正寛
 */
public final class BugDetail2Action extends BaseAction 
{
//===========================================================================
// attributes
//===========================================================================
	/**
	 * Form
	 */
	BugDetail2Form m_form;
	/**
	 * session
	 */
	HttpSession m_session;
	/**
	 * Bug
	 */
	Bug m_bug = null;
	/**
	 * Bug
	 */
	UserInfo m_logonUser;
	/**
	 * Log
	 */
	private Log log = LogFactory.getLog(this.getClass().getName());
	/**
	 * to
	 */
	private int m_toUno;
//===========================================================================
// methods
//===========================================================================
	/**
	 * exevute
	 *
	 * @param mapping The ActionMapping used to select this instance
	 * @param actionForm The optional ActionForm bean for this request (if any)
	 * @param request The HTTP request we are processing
	 * @param response The HTTP response we are creating
	 *
	 * @exception Exception if business logic throws an exception
	 */
	public ActionForward doAction(ActionMapping mapping,
				 ActionForm form,
				 HttpServletRequest request,
				 HttpServletResponse response)
				throws Exception {
		
		ActionForward forward = null;
		/*
		 * 初期処理
		 */
		m_form = (BugDetail2Form)form;	//formの取得
		m_session = getSession(request);//sessioの取得
		m_logonUser = (UserInfo)getAttribute(m_session,"UserInfo");	//ログインユーザの取得
		m_bug = (Bug)m_session.getAttribute("bug");	//バグの取得
		
		String action = m_form.getAction();
		//debug
		log.debug(	"action =" + action + 
					" submiteType = " + m_form.getSubmitType() +
					" bno = " + m_form.getBno() +
					" bno(s) = " + (m_bug == null ? "null" : ""+m_bug.getBno()));
		/*
		 * メイン処理
		 */
		//表示の場合
		if (action.equals("show")){
			
			//=========================
			//bugインスタンスの取得判定
			//=========================
			//セッションに無いかbnoが違う場合
			if ((m_bug == null) || (m_bug.getBno() != m_form.getBno())) {
				//バグインスタンスの取得
				m_bug = new Bug(m_form.getBno());
				//バグインスタンスのセット
				m_session.setAttribute("bug", m_bug);
			
			//そのバグが更新されていた場合
			} else {
				if (m_bug.isChanged()){
					//debug
					log.debug("is changed!");
					
					//バグインスタンスの取得
					m_bug = new Bug(m_form.getBno());
					//バグインスタンスのセット
					m_session.setAttribute("bug", m_bug);
				}
			}
			//入力情報セット
			PropertyUtils.copyProperties(m_form, m_bug);
			//showへ遷移
			forward = mapping.findForward("show");
			
		//更新の場合
		} else {
			
			//=========================
			//bugインスタンスの取得判定
			//=========================
			if ((m_bug == null) || (m_bug.getBno() != m_form.getBno())) {
				//警告！
				log.warn("unmatch bno ");
				//バグインスタンスの取得
				m_bug = new Bug(m_form.getBno());
				//バグインスタンスの再セット
				m_session.setAttribute("bug", m_bug);
			}
			
			//チェック
			ActionErrors errors = m_form.validate(mapping, request);
			if (!errors.empty()) {
				 saveErrors(request, errors);
				return (new ActionForward(mapping.getInput()));
			}
			
			try {
				//差分取得開始
				m_bug.startActivity();
				
				//入力情報セット
				PropertyUtils.copyProperties(m_bug, m_form);
				
				m_bug.setInputType(Bug.ITYPE_DETAIL2);	//入力情報タイプのセット
				
				//ステータスの更新
				updateStatus();
				
				//排他チェックも兼ねてまず更新する。
				m_bug.update(m_logonUser.getUno());		//更新
				
				//方針内容の追加
				m_bug.addText(m_form.getAddText(), m_logonUser);
				
				//差分の取得終了
				m_bug.endActivity();
				
				//差分を取ってくる
				Activitys act = m_bug.getActivitys();
				//メール送信不要でなければ
				if (! m_form.getDontSendMail()) {
					//メール送信
					act.sendMail(m_logonUser, request);
				}
				//履歴の出力
				act.addActivity(m_logonUser);
				
				//
				//直前でUPDATEをしているために更新内容が変わらない場合、
				//setPersistDateでのユニーク化も聞かず、排他制御エラーとなる
				//そのうちJDBCドライバを変えて実験するが、とりあえず排他チェックを
				//はずして更新する。
				
				m_bug.update(m_logonUser.getUno(), false);		//排他制御なしの更新
				
				//successへ遷移
				forward = mapping.findForward("success");
				
			//排他例外
			} catch (ExclusionException ee) {
				//debug
				log.debug("ExclusionException", ee);
				
				Varidater.addErrors("exp.exclusion", "bug", errors);
				saveErrors(request, errors);
				return (new ActionForward(mapping.getInput()));
				
			}
			
		}
		
		// Forward control to the specified success URI
		return forward;
	}
	/**
	 * ステータスの変更
	 */
	private void updateStatus() {
		
		String submitType = m_form.getSubmitType();
		
		//log
		log.debug("submiteType = " + submitType);
		log.debug("ana = " + m_form.getRequestAnalyst() +
				  " upd = " + m_form.getRequestUpdater()
		);
		
		//解析中
		if (submitType.equals("investigation")) {
			int analyst = Integer.parseInt(m_form.getRequestAnalyst());
			m_bug.setAuther(m_logonUser.getUno());	//承認者設定
			m_bug.setAuthDate(new Date());			//承認日設定
			m_bug.setAnalyst(analyst);
			
			m_bug.setStatus(Bug.STS_INVESTIGATION);
			m_bug.setDispatch();		//ディスパッチ先を決定
		
		//確認中
		} else if (submitType.equals("resolved")) {
			m_bug.setAuther(m_logonUser.getUno());	//承認者設定
			m_bug.setAuthDate(new Date());			//承認日設定
			m_bug.setComfirmer(m_bug.getIssuer());	//発行者を確認者へ
			
			m_bug.setStatus(Bug.STS_RESOLVED);
			m_bug.setDispatch();		//ディスパッチ先を決定
		
		//修正中
		} else if (submitType.equals("repaired")) {
			int updater = Integer.parseInt(m_form.getRequestUpdater());
			m_bug.setAuther(m_logonUser.getUno());	//承認者設定
			m_bug.setAuthDate(new Date());			//承認日設定
			m_bug.setUpdater(updater);				//修正者指定
			
			m_bug.setStatus(Bug.STS_REPAIRED);
			m_bug.setDispatch();		//ディスパッチ先を決定
		
		//完了
		} else if (submitType.equals("close")) {
			m_bug.setAuther(m_logonUser.getUno());		//承認者設定
			m_bug.setAuthDate(new Date());				//承認日設定
			m_bug.setComfirmer(m_logonUser.getUno());	//確認者設定
			m_bug.setComfirmDate(new Date());			//確認日設定
			
			m_bug.setStatus(Bug.STS_CLOSE);
			m_bug.setDispatch();					//ディスパッチ先を決定
		
		//再開
		} else if (submitType.equals("reopen")) {
			m_bug.setAuther(m_logonUser.getUno());	//承認者設定
			m_bug.setAuthDate(new Date());			//承認日設定
			
			m_bug.setStatus(Bug.STS_REOPEN);
			m_bug.setDispatch();					//ディスパッチ先を決定
		
		//未確認
		} else if (submitType.equals("unconfirmed")) {
			m_bug.setAuther(m_logonUser.getUno());	//承認者設定
			m_bug.setAuthDate(new Date());			//承認日設定
			
			m_bug.setStatus(Bug.STS_UNCONFIRMED);
			m_bug.setDispatch();		//ディスパッチ先を決定
		//解析引き受け
		} else if (submitType.equals("investigationOwn")) {
			m_bug.setAuther(m_logonUser.getUno());	//承認者設定
			m_bug.setAuthDate(new Date());			//承認日設定
			m_bug.setAnalyst(m_logonUser.getUno());	//解析者
			
			m_bug.setStatus(Bug.STS_INVESTIGATION);
			m_bug.setDispatch();		//ディスパッチ先を決定
		
		//申告
		} else if (submitType.equals("same")) {
			//なにもしない
			
		//ステータス状況変更
		} else if (submitType.equals("statusWhitebord")) {
			
			m_bug.setStatusWhitebord(m_form.getRequestStatusWhitebord());
			
		} else {
			//ここには来ないはず
			Assert.check(false, "invalid submitType type = " + submitType);
			
		}
	}
}
